package org.freecompany.util.text;

import java.util.Iterator;

/**
 * Iterator for obtaining {@link Character} instances from an
 * arbitrary {@link CharSequence}.
 */
public class CharSequenceIterator implements Iterator< Character> {
	
	protected CharSequence sequence;
	protected int count;

	public CharSequenceIterator( CharSequence sequence) { this.sequence = sequence; }
	public CharSequenceIterator( CharSequence sequence, int count) {
		this.count = count;
		this.sequence = sequence;
	}

	public boolean hasNext() { return count < sequence.length(); }
	public Character next() {  return sequence.charAt( count++); }
	public Character peek() {  return sequence.charAt( count); }
	public void remove() { throw new UnsupportedOperationException(); }
	public int index() { return count; }
	public String remainder() {
		return next( sequence.length() - count).toString();
	}
	public CharSequence next( final int length) {
		return sequence.subSequence( count, ( count += length));
	}
}
