package org.freecompany.util.text;

public class CharSequenceWrapper implements UnicodeSequence {
	
	private final CharSequence characters;
	
	public CharSequenceWrapper( final CharSequence characters) {
		this.characters = characters;
	}

	public int length() {
		return characters.length();
	}

	public char charAt( final int index) {
		return characters.charAt( index);
	}

	public CharSequence subSequence( final int start, final int end) {
		return characters.subSequence( start, end);
	}

	public int codePointCount() {
		return Character.codePointCount( characters, 0, characters.length());
	}

	public int codePointAt( final int index) {
		return Character.codePointAt( characters, index);
	}

	public String toString() {
		return characters.toString();
	}
}
