package org.freecompany.util.text;

import java.util.Iterator;

/**
 * Simple convenience class for building an {@link Iterable} object out of a
 * {$link CharSequence}.  The iterators provided from this object will not
 * support the ${link Iterator#remove()} method.
 */
public class IterableCharSequence implements Iterable< Character> {

	protected final CharSequence sequence;

	public IterableCharSequence( CharSequence sequence) {
		this.sequence = sequence;
	}

	public Iterator< Character> iterator() {
		return iterator( sequence);
	}

	public static Iterator< Character> iterator( final CharSequence sequence) {
		return new CharSequenceIterator( sequence);
	}
}
