package org.freecompany.util.text;

import java.util.Iterator;

/**
 * Simple convenience class for building an {@link Iterable} object that suports
 * the entire set of Unicode code points out of a {$link CharSequence}.  The iterators
 * provided from this object will not support the ${link Iterator#remove()} method.
 */
public class IterableUnicodeSequence implements Iterable< Integer> {

	protected final CharSequence sequence;

	public IterableUnicodeSequence( CharSequence sequence) {
		this.sequence = sequence;
	}

	public Iterator< Integer> iterator() {
		return iterator( sequence);
	}

	public static Iterator< Integer> iterator( final CharSequence sequence) {
		return new UnicodeSequenceIterator( sequence);
	}
}
