package org.freecompany.util.text;

public interface UnicodeSequence extends CharSequence {

	/**
	 * Returns a count of the total number of Unicode code points in
	 * this character sequence.
	 *
	 * @return the number of code points.
	 */
	int codePointCount();

	/**
	 * Decodes the code point at the specified index in this sequence. This method throws
	 * an index of out bounds exception in the case of an invalid index. The valid range
	 * of arguments is zero to {@link #codePointCount}.  If this sequence is zero length
	 * this method will always fail.
	 *
	 * @param index the index of the code point to decode and return.
	 * @return the code point at the selected index.
	 */
	int codePointAt( int index);
}
